<?php

// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 *
 * @package    format_iena
 * @category   format
 * @copyright  2018 Softia/Université lorraine
 * @author     vrignaud camille
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

require_once('../../../config.php');
	require_once('view/view_param_indicateur.php');
		require_once('entity/course_format_iena_section_ressources.php');
			require_once('entity/course_format_iena_sections.php');

				global $COURSE, $DB, $USER;

				$courseID = required_param('courseid', PARAM_INT);
				$sectionID = required_param('sectionid', PARAM_INT);
				$url = new moodle_url('/course/format/iena/param_indicateur.php', array('courseid' => $courseID));

				$PAGE->set_pagelayout('course');
				$PAGE->set_url($url);

				if (!has_capability('moodle/course:sectionvisibility', $context = context_course::instance($courseID), $USER->id)) {
					$link = $CFG->wwwroot . '/course/view.php?id=' . $courseID;
					header("Location: {$link}");
					exit;
				}
				$course = $DB->get_record('course', array('id' => $courseID), '*', MUST_EXIST);
				require_login($course, false, NULL);

				$PAGE->set_title('Indicateurs de suivi');
				$PAGE->set_heading('Indicateurs de suivi');

				/* Update in Database all tables format_iena_settings for each module */
				if ($_POST) {

					if ($_POST['select-section']) {
						$sectionid = $_POST['select-section'];
						$sectionid = explode('-', $sectionid)[1];
					} else {
						$sectionid = "undefined";
					}

					/* Récupération de l'état des modules du formulaire */
					$posted_module_ids = [];
					$y = 0;
					foreach ($_POST as $key => $form_module) {
						$temp = explode($_POST['select-section'], $key);
						if (count($temp) > 1) {
							$posted_module_ids[$y] = $temp[0];
						}
						$y++;
					}

					$all_modules = explode("-", $_POST['all_modules']);


					

					// echo "<pre>";
/* var_dump($_POST);
echo "---<br>";
var_dump($all_modules);
echo "---<br>";
var_dump($posted_module_ids);
die; */

$suivi_records = $DB->get_records('format_iena_settings', array('sectionid' => $sectionid));

/* pour chaque activité du cours */
foreach ($all_modules as $course_mod_id) {
	$done = false;
	/* pour chaque activité suivie ou non en base */
	foreach ($suivi_records as $record) {
		/* si l'activité est en base (suivie ou non) */
		if ( $record->cmid == $course_mod_id ) {
			/* l'activité est suivie en base (1 ou 0 => true, false) */
			$is_suivi = $record->hide == 1 ? true : false;
			/* l'activité a été checkée pour être suivie à présent (true ou false) */
			$is_ask_suivi = in_array($record->cmid, $posted_module_ids);
			/* si l'état de suivi de l'activité n'est pas le même que demandé */
			if ( $is_suivi !== $is_ask_suivi ) {
				/* mise à jour de l'état de l'activité suivie */
				$update = new stdClass();
				$update->id = $record->id;
				$update->hide = $is_ask_suivi ? 1 : 0;
				$DB->update_record('format_iena_settings', $update, false);
				/* l'activité a été traitée */
				$done = true;
			} else {
				/* l'activité n'a pas besoin d'être traitée */
				$done = true;
			}
		}
	}
	/* si l'activité n'est pas en base (n'a pas été traitée) */
	if ( $done == false ) {
		/* si l'activité a été checkée pour être suivie à présent (true ou false) */
		if ( in_array($course_mod_id, $posted_module_ids) ) {
			$insert = new stdClass();
			$insert->courseid = $COURSE->id;
			$insert->cmid = $course_mod_id;
			$insert->hide = 1;
			$insert->sectionid = $sectionid;
			$DB->insert_record('format_iena_settings', $insert, false);
		}
	}
}

// die;


/*

$DB->insert_record('format_iena_settings', $format_iena_setting_data, false);

Records (0 ou 1)
Form (1)

Pour chaque activité $all_modules
	Enregistrement traité = faux
	Pour chaque enregistrement $suivi_records
		Si l'enregistement $posted_module_ids existe dans $suivi_records
			Si l'enregistrement est différent
				Modifier l'enregistrement
				Enregistrement traité = vrai
				Break
	Si Enregistrement traité == faux
		Créer l'enregistrement

*/


		// foreach ($posted_module_ids as $module_id) {
		// 	$prev_record_exists = false;
		// 	foreach ( $suivi_records as $record ) {
		// 		if ( $module_id == $record->cmid ) {
		// 			$update = new stdClass();
		// 			$update->id = $record->id;
		// 			$update->hide = 1;
		// 			$DB->update_record('format_iena_settings', $update, false);
					$prev_record_exists = true;
		// 			break;
		// 		}
		// 	}
		// 	if ( !$prev_record_exists ) {
		// 		$insert = new stdClass();
		// 		$insert->courseid = $COURSE->id;
		// 		$insert->cmid = $module_id;
		// 		$insert->hide = 1;
		// 		$insert->sectionid = $sectionid;
		// 		$DB->insert_record('format_iena_settings', $insert, false);
		// 	}
		// }

		





		/*---*/


		// // récupération de l'état des modules dans la BDD
  // $modulesStates = $DB->get_records('format_iena_settings', array('sectionid' => $sectionid));

  // foreach ($modulesStates as $module) {
		// 	//var_dump($modulesStates);
		// 	// Création de l'objet à updater
		// 	//$format_iena_setting_data_upd = new stdClass();
  // 	$indic = false;
  // 	foreach ($posted_module_ids as $form_module) {
  // 		if ($module->cmid == $form_module) {
  // 			$format_iena_setting_data_upd = new stdClass();
  // 			$format_iena_setting_data_upd->hide = 1;
  // 			$format_iena_setting_data_upd->sectionid = $sectionid;
  // 			$format_iena_setting_data_upd->id = $module->id;
  // 			$DB->update_record('format_iena_settings', $format_iena_setting_data_upd, false);
  // 			$indic = true;
  // 			break;
  // 		}
  // 	}
  // 	if ($indic == false) {
  // 		$format_iena_setting_data_upd = new stdClass();
  // 		$format_iena_setting_data_upd->hide = 0;
  // 		$format_iena_setting_data_upd->sectionid = $sectionid;
  // 		$format_iena_setting_data_upd->id = $module->id;
  // 		$DB->update_record('format_iena_settings', $format_iena_setting_data_upd, false);
  // 	}
  // }



		$link = $CFG->wwwroot . '/course/format/iena/suivi_unit.php?courseid=' . $courseID . '&sectionid=' . $sectionid;
		header("Location: {$link}");
		exit;



	} elseif ( $_GET['sectionid'] ) {

		echo $OUTPUT->header();

		$get_section_id = $_GET['sectionid'];

		$modinfo = get_fast_modinfo($COURSE->id);

		$sections = $modinfo->get_section_info_all();

		$suivi_cms = $DB->get_records_sql('SELECT id, cmid, hide from {format_iena_settings} where courseid = ? and sectionid = ?', array($COURSE->id, $get_section_id));

		$is_course_section = false;
		$current_section_name = "";

		$sections_arr = [];

		foreach ($sections as $section_num => $section) {

			$section_id = $section->__get('id');
			$section_name = $section->__get('name');
			if ( $section_name == NULL ) {
				$section_name = "Section " . $section_num;
			}
			if ( $section_id == $get_section_id ) {
				$is_course_section = true;
				$current_section_name = $section_name;
				$current_section_id = $section_id;
			}

			$section_cms = [];
			foreach ($modinfo->get_cms() as $module) {
				if ( $module->section == $section_id ) {
					$mod = new stdClass();
					$mod->moduleid = $module->id;
					$mod->name = $module->name;
					$mod->courseid = $module->course;
					$mod->sectionid = $module->section;
					foreach ($suivi_cms as $suivi) {
						if ( $module->id == $suivi->cmid ) {
							if ( $suivi->hide == 1 ) {
								$mod->suivi = 1;
							} else {
								$mod->suivi = 0;
							}
						}
					}
					array_push($section_cms, $mod);
				}
			}

			$sec = new stdClass();
			$sec->id = $section_id;
			$sec->name = $section_name;
			$sec->modules = $section_cms;
			$sections_arr[] = $sec;
		}

		if ( $is_course_section == false ) {
			echo "<p class='alert alert-warning'>Id de section invalide</p>";
			echo $OUTPUT->footer();
		} else {
			// echo "<pre>";
			// var_dump($sections_arr);
			// echo "</pre>";
			$view_param_indicateur = new view_param_indicateur();
			echo $view_param_indicateur->get_content($sections_arr, $current_section_name, $current_section_id);
			echo $OUTPUT->footer();
		}

	} else {
		$link = $CFG->wwwroot . '/course/view.php?id=' . $courseID;
		header("Location: {$link}");
		exit;
	}

//	$PAGE->requires->js("/course/format/Sprint3/js/jquery.min.js");
//	$PAGE->requires->js("/course/format/iena/js/file.js");
//	$PAGE->requires->js_call_amd("/course/format/Sprint3/js/jquery.dataTables.js",  'init');
	// echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"normalize.css\">";
	// echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"common.css\">";
	// echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"https://cdn.datatables.net/1.10.16/css/jquery.dataTables.css\">";
	// echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"styles.css\">";



	// var_dump(count($modinfo->get_cms()));

	// $suivi_cms = $DB->get_records_sql('SELECT id, cmid, hide from {format_iena_settings}
	// 	where courseid = ? and sectionid = ?', array($COURSE->id, 124));

	// echo "<pre>";
	// var_dump($suivi_cms);
	// echo "</pre>";










	// echo $OUTPUT->footer();
	// die;


	// $view_param_indicateur = new view_param_indicateur();
	// $sections = $view_param_indicateur->get_course_sections_modules();




	// $Tab_id_modules = array();
	// $i = 0;

	// foreach ($sections as $section) {
	// 	foreach ($section->ressources as $mod) {
	// 		$Tab_id_modules[$i] = $mod->id;
	// 		$i++;
	// 	}
	// }

	// $initee="avant creation";

	// var_dump($initee);

	// die;

	// $suivi_cms = $DB->get_records_sql('SELECT * from {format_iena_settings}
	// 	where courseid = ?', array($COURSE->id));

	// // var_dump($suivi_cms);

	// // die;

	// $inidezaaaatee="apres premiere requete";

	// var_dump($inidezaaaatee);

	// $to_insert = [];

	// foreach ($sections as $section) {
	// 	foreach ($Tab_id_modules as $id_module) {
	// 		// $verif_db = $DB->get_record('format_iena_settings', array('cmid' => $id_module, 'sectionid' => $section->id), '*');

	// 		$verif_db = false;
	// 		foreach ($suivi_cms as $suivi_cm) {
	// 			if ( $suivi_cm->cmid == $id_module && $suivi_cm->sectionid == $section->id ) {
	// 				$verif_db = true;
	// 				break;
	// 			}
	// 		}

	// 		// if ($verif_db == false) {
	// 		if ($verif_db == false) {
	// 			$format_iena_setting_data = new stdClass();
	// 			$format_iena_setting_data->cmid = $id_module;
	// 			$format_iena_setting_data->hide = 0;
	// 			$format_iena_setting_data->courseid = $COURSE->id;
	// 			$format_iena_setting_data->sectionid = $section->id;
	// 			array_push($to_insert, $format_iena_setting_data);
	// 			// $DB->insert_record('format_iena_settings', $format_iena_setting_data, false);
	// 		}
	// 	}
	// }

	// $indezite="avant requete";

	// var_dump($indezite);

	// if ( count($to_insert) > 0 ) {
	// 	$DB->insert_records('format_iena_settings', $to_insert);
	// }

	// $inite="initialisation terminée";

	// var_dump($inite);


	// echo $view_param_indicateur->get_content();
	// echo $OUTPUT->footer();
