<?php
	/**
	 * Created by PhpStorm.
	 * User: softia
	 * Date: 06/03/18
	 * Time: 10:20
	 */

// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
	
	/**
	 *
	 * @package    format_iena
	 * @category   format
	 * @copyright  2018 Softia/Université lorraine
	 * @author     vrignaud camille
	 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
	 */
	
	define('NO_OUTPUT_BUFFERING', true);
	require_once('../../../config.php');
	
	global $COURSE, $DB, $USER, $CFG;
	
	$courseID = required_param('courseid', PARAM_INT);
	$url = new moodle_url('/course/format/iena/send_message.php', array('courseid' => $courseID));
	
	$PAGE->set_pagelayout('course');
	$PAGE->set_url($url);
	
	if (!has_capability('course/iena:suivi', $context = context_course::instance($courseID), $USER->id)) {
		$link = $CFG->wwwroot . '/course/view.php?id=' . $courseID;
		header("Location: {$link}");
		exit;
	}
	
	$course = $DB->get_record('course', array('id' => $courseID), '*', MUST_EXIST);
	require_login($course, false, NULL);
	
	/*if (isset($_POST['action'])) {
		$messageContent = $_POST['summary']['text'];
		$usersid = explode(",", $_POST["usersid"]);
		// $messageContent .= "<br>". get_string('course', 'format_iena') . " : " . $course->fullname;
		$messageContent .= "<br>". get_string('course', 'format_iena') . " :  <a href='" . $CFG->wwwroot . "/course/view.php?id=" . $course->id . "'>" . $course->fullname . "</a>";
		$messageContent .= "<br> ". get_string('prof', 'format_iena') . " : " . $USER->firstname . " " . $USER->lastname;
		$brutMessageContent = $course->fullname . " " . $_POST['summary']['text'];
		$course_ctx = context_course::instance($courseID);
		$students = get_enrolled_users($course_ctx);
		
		// sending a notification to each students
		foreach ($usersid as $userID) {
			foreach ($students as $student) {
				if ($student->id == $userID) {
					$message = new \core\message\message();
					$message->courseid = $course->id;
					$message->component = 'moodle';
					$message->name = 'instantmessage';
					$message->userfrom = $USER;
					$message->notification = '0';
					$message->fullmessageformat = FORMAT_HTML;
					$message->subject = "Rappel : " . $course->fullname;
					$message->smallmessage = $messageContent;
					$message->fullmessage = $brutMessageContent;
					$message->fullmessagehtml = $messageContent;
					$message->userto = $student;
					$messageid = message_send($message);
					break;
				}
			}
		}
		$link = $CFG->wwwroot . '/course/view.php?id=' . $courseID;
		header("Location: {$link}");
		exit;
	}*/
	
	//$dataSection = $DB->get_record('format_iena', array('id_section' => $sectionId), '*');
	//$course = $DB->get_record('course', array('id' => $courseID), '*', MUST_EXIST);
	// require_login($course, false, NULL);

	$students="";
	$back_url=$CFG->wwwroot . '/course/view.php?id=' . $courseID;
	
	if(isset($_POST["students"])){
		$students=$_POST["students"];
	}
	if(isset($_POST["back_url"])){
		$back_url=$_POST["back_url"];
		
	}


	$data=new stdClass();
	$nb = $students != "" ? count( explode(",", $students) ) : 0;
	require_once('entity/course_format_iena_message.php');
	$send_message = new course_format_iena_message(null, array('back_url'=>$back_url, 'students'=>$students));
	
	if ( $nb == 0 ) {
		$data->nb_results=0;
		
	} else {
		$data->nb_results=$nb;
		$data->users_id=$students;
		$courseID = required_param('courseid', PARAM_INT);
		$data->link_cancel= $CFG->wwwroot . "/course/view.php?id=" . $courseID;;
		$data->form=$send_message->render();
	}

	

	
	//if form is cancelled, we go back to the table. Else, we send the message and then go back to the table, with a success or failure message.
	if($send_message->is_cancelled()){
		$back_url=$CFG->wwwroot . '/course/format/iena/suivi_unit.php'.$back_url;
		
		header("Location: {$back_url}");
	}
	else if ($fromform = $send_message->get_data()) {
		$back_url=$CFG->wwwroot . '/course/format/iena/suivi_unit.php'.$back_url;
		
		try{
			$messageContent = $fromform->summary['text'];
			
			$usersid = explode(",", $fromform->students);
			
			$messageContent .= "<br>". get_string('course', 'format_iena') . " :  <a href='" . $CFG->wwwroot . "/course/view.php?id=" . $course->id . "'>" . $course->fullname . "</a>";
			$messageContent .= "<br> ". get_string('prof', 'format_iena') . " : " . $USER->firstname . " " . $USER->lastname;
			$brutMessageContent = $course->fullname . " " . $_POST['summary']['text'];
			$course_ctx = context_course::instance($courseID);
			$students = get_enrolled_users($course_ctx);
			
			// sending a notification to each students
			foreach ($usersid as $userID) {
				foreach ($students as $student) {
					if ($student->id == $userID) {
						$message = new \core\message\message();
						$message->courseid = $course->id;
						$message->component = 'moodle';
						$message->name = 'instantmessage';
						$message->userfrom = $USER;
						$message->notification = '0';
						$message->fullmessageformat = FORMAT_HTML;
						$message->subject = "Rappel : " . $course->fullname;
						$message->smallmessage = $messageContent;
						$message->fullmessage = $brutMessageContent;
						$message->fullmessagehtml = $messageContent;
						$message->userto = $student;
						$messageid = message_send($message);
						break;
					}
				}
			}
			$back_url.="&msg_success=true";
		}
		catch(Exception $e){
			$back_url.="&msg_failure=true";
		}
		
    	header("Location: {$back_url}");
	}
	else{
		echo $OUTPUT->header();
		$renderer = $PAGE->get_renderer('format_iena');
		$renderer->display_message($data);
		echo $OUTPUT->footer();
	}



	//echo $view_param_section->get_content($course, $dataSection);
	
	
	
	

